define("io.ox/office/tk/utils/driveutils",["io.ox/files/api","io.ox/core/folder/api","io.ox/core/folder/node","io.ox/core/folder/tree","io.ox/core/tk/selection","io.ox/core/permissions/permissions","io.ox/office/tk/utils","io.ox/office/tk/keycodes","io.ox/office/tk/object/triggerobject","settings!io.ox/files"],function(e,r,t,n,i,o,l,a,s,d){"use strict";function c(e){return _.isNull(e)||_.isUndefined(e)?e:String(e)}function u(e){return(e=c(e))||S.getMyFilesId()}function f(e){if(e)throw l.error("DriveUtils fn failed:"+e.error_desc+' code:"'+e.code+'" error:"'+e.error+'"'),b[e.code]||E;throw l.error("DriveUtils fn failed"),E}function g(e){if(/^virtual/.test(e))return!0;var t=r.pool.models[e];if(!t)return l.warn("DriveUtils.shouldBeDisabled() is called to early, folder is not cached yet. better call DriveUtils.getWriteState() folder_id: "+e),!0;var n=t.toJSON();return!h("can","write",n)||(!h("can","create",n)||void 0)}function h(e,t,n){return r[e](t,n)}function p(e,r,t){return F(t),S.getPath(t).then(function(t){var n=_.last(t);return h(e,r,n)},function(){return null})}function v(e,t,n){return r.get(n,{cache:!1}).then(function(r){var n=!1;return _.each(r.permissions,function(r,i){i&&h(e,t,{own_rights:r.bits})&&(n=!0)}),n})}function F(e){if(!_.isString(e))throw l.error("id is no string:",e),new Error("missing identifier")}function w(e,r){e.find(".folder-node>.folder-label div").css("overflow","visible"),e.on("click",function(){var t=e.parent().parent().find("li.folder.selectable");t.removeClass("selected"),t.attr("aria-selected",!1),t.attr("tabindex",-1),e.addClass("selected"),e.attr("aria-selected",!0),e.attr("tabindex",0),l.setFocus(e),r.trigger("select")}),e.on("keydown",function(r){var t=0;if(r.keyCode===a.UP_ARROW)t--;else{if(r.keyCode!==a.DOWN_ARROW)return;t++}var n=e.parent().parent().find("li.folder.selectable:visible"),i=null;_.find(n,function(r,t){if(e[0].isSameNode(r))return i=t,!0}),$(n[i+t]).trigger("click")})}var m=new RegExp("^(.+?)\\."+_.escapeRegExp("pgp")+"$","i"),x=new RegExp("^(.*?)\\.([^.]+)(\\."+_.escapeRegExp("pgp")+")?$","i"),E={errorForErrorCode:!0,error:"GENERAL_UNKNOWN_ERROR"},b={"FILE_STORAGE-0026":{errorForErrorCode:!0,error:"GENERAL_FILE_NOT_FOUND_ERROR.LOAD",errorClass:2},"IFO-0400":{errorForErrorCode:!0,error:"WARNING_NO_PERMISSION_FOR_DOC",errorClass:1},"IFO-0438":{errorForErrorCode:!0,error:"GENERAL_FILE_NOT_FOUND_ERROR.LOAD",errorClass:2}},S={},R={options:{customize:$.noop,disable:$.noop,filter:$.noop}};return S.getSanitizedFileName=function(e,r){var t=_.isObject(e)?e["com.openexchange.file.sanitizedFilename"]||e.filename:null;return"string"==typeof t&&t.length>0?t:"string"==typeof r?r:null},S.GUARD_EXT=".pgp",S.hasGuardExt=function(e){return m.test(e)},S.removeGuardExt=function(e){var r=m.exec(e);return r?r[1]:e},S.authorizeGuard=function(e){return require(["io.ox/guard/auth/authorizer"]).then(function(r){return r.authorize(e)})},S.getFileBaseName=function(e){var r=x.exec(e);return r?r[1]:e},S.getFileExtension=function(e){var r=x.exec(e);return r?r[2].toLowerCase():""},S.replaceFileExtension=function(e,r){var t=S.getFileBaseName(e)+"."+r;return S.hasGuardExt(e)&&(t+=S.GUARD_EXT),t},S.purgeFile=function(r){return e.remove([r],!0)},S.isGuest=function(){return null===S.getMyFilesId()},S.getAllFiles=function(r){return e.getAll(r)},S.getFileUrl=function(r,t,n){return e.getUrl(r,t,n)},S.propagateChangeFile=function(r){return e.propagate("add:version",r).then(function(){return S.getFile(r,{cache:!1,columns:"1,2,3,5,20,23,108,109,700,701,702,703,704,705,706,707,708,709,710,711,7010,7030"})})},S.getFile=function(r,t){return e.get(r,t).catch(f)},S.propagateNewFile=function(r){return e.propagate("add:file",r),S.getFile(r)},S.isDriveFile=function(e){return e&&!e.source&&l.warn("assigned file has no source. please change that."),e&&("drive"===e.source||!e.source)},S.getFileModelFromDescriptor=function(r){return S.getFile(r).then(function(t){var n=e.pool.get("detail").get(_.cid(t));if(!n)throw new Error("DriveUtils.getFileModelFromDescriptor() model is null "+r);return n.clone()})},S.getFileVersions=function(r,t){return e.versions.load(r,t).catch(f)},S.getCurrentFileVersionState=function(r,t){return e.versions.getCurrentState(r,t).catch(f)},S.FlatFolderPicker=s.extend({constructor:function(e,r){function t(){c=d.find(".folder.selected").attr("data-id"),i.trigger("change")}function n(r){function t(){o.parent().find("li.folder").show(),l.removeClass("fa-caret-right"),l.addClass("fa-caret-down")}function n(){o.parent().find("li.folder:not(.section)").hide(),l.removeClass("fa-caret-down"),l.addClass("fa-caret-right")}var i=new s(e),o=$('<li class="section folder selectable"><div class="folder-node" role="presentation" style="padding-left: 0px;"><div class="folder-arrow"><i class="fa fa-caret-down"></i></div><div class="folder-icon"><i class="fa fa-fw"></i></div><div class="folder-label" style="font-weight: bold;"><div>'+r+"</div></div></div></li>");w(o,i);var l=o.find(".folder-arrow>i");return o.on("keydown",function(e){e.keyCode===a.LEFT_ARROW?n():e.keyCode===a.RIGHT_ARROW&&t()}),l.parent().on("click",function(){l.hasClass("fa-caret-down")?n():t()}),i.render=function(){return{$el:o}},i}var i=this;s.call(this,e);var o=l.getStringOption(r,"folderId"),d=$('<div class="folder-tree visible-selection dropzone" role="navigation" data-dropzones=".selectable">'),c=null;this.addFolders=function(e,r){if(r.length){var i=$('<ul class="tree-container f6-target" role="tree">');i.appendTo(d);var l=n(e);l.on("select",t),l.render().$el.appendTo(i),_.each(r,function(e){var r=$("<li>");r.appendTo(i),S.getCreateState(e).always(function(n){if(n){var a=S.newFolderPickerNode(e);a.on("select",t),S.getPath(e).done(function(e){if(e.length>2){for(var r=e[1].title,t=2;t<e.length-0;t++)r+=" / "+e[t].title;r=S.getShortenedTitle(r,40),a.render().$el.find(".folder-label").text(r)}}),r.replaceWith(a.render().$el),e===o&&a.render().$el.click(),l.render().$el.attr("data-id",i.find("li[data-id]").first().attr("data-id"))}else r.remove(),i.children().length<=1&&i.remove()})})}},this.getNode=function(){return d},this.getFolderId=function(){return c}}}),S.FolderPicker=s.extend({constructor:function(e,r){var t=this,o=null;s.call(this,e);var a=l.getStringOption(r,"folderId"),d=new n({persistent:!1,tabindex:0,root:S.getRootId(),all:!1,module:"infostore",abs:!1,filter:S.getPickerFilter(),customize:S.getPickerCustomizer(),highlightclass:l.SMALL_DEVICE?"visible-selection-smartphone":"visible-selection"});d.render();var c=d.$el;i.extend(d,c,{}),c.addClass("drive-folder-list"),d.on("change virtual",function(e){o=g(e)?null:e,t.trigger("change")}),a&&S.preselectFolder(d,a),this.getNode=function(){return c},this.getFolderId=function(){return o},this.selectFolder=function(e){S.preselectFolder(d,e)}}}),S.getTrashState=function(e){return p("is","trash",e)},S.getCreateState=function(e){return p("can","create",e)},S.getWriteState=function(e){return p("can","write",e)},S.canModify=function(t){if(!t)return l.error("DriveUtils.canModify() no file assigned"),!1;var n=e.pool.get("detail").get(_.cid(t));if(S.isGuest()){var i=_.findWhere(n.get("object_permissions"),{entity:ox.user_id});return Boolean(i&&i.bits>=2)}var o=r.pool.models[n.get("folder_id")];return o?h("can","write",o.toJSON()):(l.warn("DriveUtils.canModify() is called too early, folder is not cached yet. better call DriveUtils.getWriteState() file: "+t),!1)},S.isShareable=function(e){if(!e)return l.error("DriveUtils.isShareable() no file assigned"),!1;var t=r.pool.models[e.folder_id];return t?t.isShareable():(l.warn("DriveUtils.isShareable() is called too early, folder is not cached yet. better call DriveUtils.getWriteState() file: "+e),!1)},S.isExternalFolder=function(e){return e&&void 0!==e.folder_id?r.get(e.folder_id).then(function(e){return!!e&&(e&&r.isExternalFileStorage(e))}):(l.error("DriveUtils.isExternalFolder() no file assigned"),$.when(!1))},S.isTrash=function(e){var t=r.pool.models[e];return t?h("is","trash",t.toJSON()):(l.warn("DriveUtils.isTrash() is called to early, folder is not cached yet. better call DriveUtils.getTrashState() id: "+e),!1)},S.getPath=function(e){return F(e),r.path(e)},S.hasFolderReadPermissions=function(e){return v("can","read",e)},S.getStandardDocumentsFolderId=function(){return u(d.get("folder/documents"))},S.getStandardPicturesFolderId=function(){return u(d.get("folder/pictures"))},S.getStandardTemplateFolderId=function(){return u(d.get("folder/templates"))},S.getStandardTrashFolderId=function(){return u(d.get("folder/trash"))},S.getMyFilesId=function(){return c(r.getDefaultFolder("infostore"))},S.getRootId=function(){return"9"},S.getPickerFilter=function(){return function(e,r){if(h("is","trash",r.toJSON()))return!1}},S.getPickerCustomizer=function(){return function(e){g(e.data.id)&&this.addClass("disabled")}},S.newFolderPickerNode=function(e){var r=new t({indent:!0,empty:!0,subfolders:!1,folder:e,tree:R,parent:R}),n=r.render().$el;return n.find(".folder-node").css("pointer-events","none"),w(n,r),r},S.getShortenedTitle=function(e,t){return r.getFolderTitle(e,t)},S.deleteFromCache=function(e){try{delete r.pool.models[e]}catch(e){l.warn("cannot delete FolderAPI.pool.models",e)}},S.showPermissionsDialog=function(e){return o.show(e)},S.preselectFolder=function(e,r){function t(){var i=0;if(window.clearTimeout(n),e.off("appear",t),r){var o=function(r,t){var n=t[r].id,l=e.$el.find('.folder[data-id="'+n+'"]');if(l.length){i=0;var a=t[r+1];if(!a)return void l.click();e.once("appear:"+a.id,function(){o(r+1,t)}),"false"===l.attr("aria-expanded")&&l.find(".folder-arrow").click(),e.appear({folder:a.id})}else i<3&&window.setTimeout(function(){o(r,t)},200),i++};S.getPath(r).done(function(e){o(1,e)})}else{var a=e.selection;a&&(a.updateIndex().selectFirst(),l.setFocus(e.$el.find(".selected")))}}var n=null;e.once("appear",t),n=window.setTimeout(t,250)},S.preparePath=function(e){var r=_.pluck(_.rest(e),"title");return _.each(r,function(e,t){r[t]=e.replace(/\s/g," ")}),_.pluck(_.rest(e),"title").join(" / ")},S});